/*
 * Copyright (C) 2001 USAGI/WIDE Project.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the project nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE PROJECT AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE PROJECT OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * $USAGI: sadb_utils.h,v 1.4 2001/08/15 06:30:29 mk Exp $
 */

#ifndef __SADB_MISC_H
#define __SADB_MISC_H

#include <linux/types.h>
#include <linux/net.h>
#include <linux/in.h>
#include <linux/in6.h>
#include <linux/errno.h>

#include <net/sadb.h>


/* Function addrtoa converts sockaddr to ascii */
/* It returns the length, if it scceed. Otherwise it return 0.*/
size_t sockaddrtoa(struct sockaddr *addr, char *buf, size_t buflen);

char* authtoa(__u8 auth);
char* esptoa(__u8 esp);

int compare_sockaddr(struct sockaddr* addr1, struct sockaddr* addr2);
int compare_address(struct sockaddr* addr1, struct sockaddr* addr2);

void dump_sa_lifetime(struct sa_lifetime *lifetime);
void dump_sa_replay_window(struct sa_replay_window *window);
void dump_sa_auth_algo(struct auth_algo_info *auth_algo);
void dump_sa_esp_algo(struct esp_algo_info *esp_algo);
void dump_ipsec_sa(struct ipsec_sa *sa);

#endif /* __SADB_MISC_H */
